Index: pjproject/trunk/build.symbian/pjlibU.def
===================================================================
--- pjproject/trunk/build.symbian/pjlibU.def	(revision 1405)
+++ pjproject/trunk/build.symbian/pjlibU.def	(revision 1410)
@@ -5,286 +5,288 @@
 	PJ_FD_SET                                @ 4 NONAME
 	PJ_FD_ZERO                               @ 5 NONAME
-	pj_AF_INET                               @ 6 NONAME
-	pj_AF_INET6                              @ 7 NONAME
-	pj_AF_IRDA                               @ 8 NONAME
-	pj_AF_PACKET                             @ 9 NONAME
-	pj_AF_UNIX                               @ 10 NONAME
-	pj_IPTOS_LOWDELAY                        @ 11 NONAME
-	pj_IPTOS_MINCOST                         @ 12 NONAME
-	pj_IPTOS_RELIABILITY                     @ 13 NONAME
-	pj_IPTOS_THROUGHPUT                      @ 14 NONAME
-	pj_IP_TOS                                @ 15 NONAME
-	pj_MSG_DONTROUTE                         @ 16 NONAME
-	pj_MSG_OOB                               @ 17 NONAME
-	pj_MSG_PEEK                              @ 18 NONAME
-	pj_SOCK_DGRAM                            @ 19 NONAME
-	pj_SOCK_RAW                              @ 20 NONAME
-	pj_SOCK_RDM                              @ 21 NONAME
-	pj_SOCK_STREAM                           @ 22 NONAME
-	pj_SOL_IP                                @ 23 NONAME
-	pj_SOL_IPV6                              @ 24 NONAME
-	pj_SOL_SOCKET                            @ 25 NONAME
-	pj_SOL_TCP                               @ 26 NONAME
-	pj_SOL_UDP                               @ 27 NONAME
-	pj_SO_RCVBUF                             @ 28 NONAME
-	pj_SO_SNDBUF                             @ 29 NONAME
-	pj_SO_TYPE                               @ 30 NONAME
-	pj_ansi_to_unicode                       @ 31 NONAME
-	pj_array_erase                           @ 32 NONAME
-	pj_array_find                            @ 33 NONAME
-	pj_array_insert                          @ 34 NONAME
-	pj_atexit                                @ 35 NONAME
-	pj_atomic_add                            @ 36 NONAME
-	pj_atomic_add_and_get                    @ 37 NONAME
-	pj_atomic_create                         @ 38 NONAME
-	pj_atomic_dec                            @ 39 NONAME
-	pj_atomic_dec_and_get                    @ 40 NONAME
-	pj_atomic_destroy                        @ 41 NONAME
-	pj_atomic_get                            @ 42 NONAME
-	pj_atomic_inc                            @ 43 NONAME
-	pj_atomic_inc_and_get                    @ 44 NONAME
-	pj_atomic_set                            @ 45 NONAME
-	pj_caching_pool_destroy                  @ 46 NONAME
-	pj_caching_pool_init                     @ 47 NONAME
-	pj_create_random_string                  @ 48 NONAME
-	pj_create_unique_string                  @ 49 NONAME
-	pj_dump_config                           @ 50 NONAME
-	pj_elapsed_cycle                         @ 51 NONAME
-	pj_elapsed_msec                          @ 52 NONAME
-	pj_elapsed_nanosec                       @ 53 NONAME
-	pj_elapsed_time                          @ 54 NONAME
-	pj_elapsed_usec                          @ 55 NONAME
-	pj_enter_critical_section                @ 56 NONAME
-	pj_enum_ip_interface                     @ 57 NONAME
-	pj_enum_ip_route                         @ 58 NONAME
-	pj_exception_id_alloc                    @ 59 NONAME
-	pj_exception_id_free                     @ 60 NONAME
-	pj_exception_id_name                     @ 61 NONAME
-	pj_fifobuf_alloc                         @ 62 NONAME
-	pj_fifobuf_free                          @ 63 NONAME
-	pj_fifobuf_init                          @ 64 NONAME
-	pj_fifobuf_max_size                      @ 65 NONAME
-	pj_fifobuf_unalloc                       @ 66 NONAME
-	pj_file_close                            @ 67 NONAME
-	pj_file_delete                           @ 68 NONAME
-	pj_file_exists                           @ 69 NONAME
-	pj_file_flush                            @ 70 NONAME
-	pj_file_getpos                           @ 71 NONAME
-	pj_file_getstat                          @ 72 NONAME
-	pj_file_move                             @ 73 NONAME
-	pj_file_open                             @ 74 NONAME
-	pj_file_read                             @ 75 NONAME
-	pj_file_setpos                           @ 76 NONAME
-	pj_file_size                             @ 77 NONAME
-	pj_file_write                            @ 78 NONAME
-	pj_generate_unique_string                @ 79 NONAME
-	pj_get_netos_error                       @ 80 NONAME
-	pj_get_os_error                          @ 81 NONAME
-	pj_get_timestamp                         @ 82 NONAME
-	pj_get_timestamp_freq                    @ 83 NONAME
-	pj_gethostaddr                           @ 84 NONAME
-	pj_gethostbyname                         @ 85 NONAME
-	pj_gethostip                             @ 86 NONAME
-	pj_gethostname                           @ 87 NONAME
-	pj_getpid                                @ 88 NONAME
-	pj_gettimeofday                          @ 89 NONAME
-	pj_hash_calc                             @ 90 NONAME
-	pj_hash_calc_tolower                     @ 91 NONAME
-	pj_hash_count                            @ 92 NONAME
-	pj_hash_create                           @ 93 NONAME
-	pj_hash_first                            @ 94 NONAME
-	pj_hash_get                              @ 95 NONAME
-	pj_hash_next                             @ 96 NONAME
-	pj_hash_set                              @ 97 NONAME
-	pj_hash_set_np                           @ 98 NONAME
-	pj_hash_this                             @ 99 NONAME
-	pj_htonl                                 @ 100 NONAME
-	pj_htons                                 @ 101 NONAME
-	pj_inet_addr                             @ 102 NONAME
-	pj_inet_addr2                            @ 103 NONAME
-	pj_inet_aton                             @ 104 NONAME
-	pj_inet_ntoa                             @ 105 NONAME
-	pj_init                                  @ 106 NONAME
-	pj_ioqueue_accept                        @ 107 NONAME
-	pj_ioqueue_connect                       @ 108 NONAME
-	pj_ioqueue_create                        @ 109 NONAME
-	pj_ioqueue_destroy                       @ 110 NONAME
-	pj_ioqueue_get_user_data                 @ 111 NONAME
-	pj_ioqueue_is_pending                    @ 112 NONAME
-	pj_ioqueue_name                          @ 113 NONAME
-	pj_ioqueue_op_key_init                   @ 114 NONAME
-	pj_ioqueue_poll                          @ 115 NONAME
-	pj_ioqueue_post_completion               @ 116 NONAME
-	pj_ioqueue_recv                          @ 117 NONAME
-	pj_ioqueue_recvfrom                      @ 118 NONAME
-	pj_ioqueue_register_sock                 @ 119 NONAME
-	pj_ioqueue_send                          @ 120 NONAME
-	pj_ioqueue_sendto                        @ 121 NONAME
-	pj_ioqueue_set_lock                      @ 122 NONAME
-	pj_ioqueue_set_user_data                 @ 123 NONAME
-	pj_ioqueue_unregister                    @ 124 NONAME
-	pj_leave_critical_section                @ 125 NONAME
-	pj_list_erase                            @ 126 NONAME
-	pj_list_find_node                        @ 127 NONAME
-	pj_list_insert_after                     @ 128 NONAME
-	pj_list_insert_before                    @ 129 NONAME
-	pj_list_insert_nodes_after               @ 130 NONAME
-	pj_list_insert_nodes_before              @ 131 NONAME
-	pj_list_merge_first                      @ 132 NONAME
-	pj_list_merge_last                       @ 133 NONAME
-	pj_list_search                           @ 134 NONAME
-	pj_list_size                             @ 135 NONAME
-	pj_lock_acquire                          @ 136 NONAME
-	pj_lock_create_null_mutex                @ 137 NONAME
-	pj_lock_create_recursive_mutex           @ 138 NONAME
-	pj_lock_create_semaphore                 @ 139 NONAME
-	pj_lock_create_simple_mutex              @ 140 NONAME
-	pj_lock_destroy                          @ 141 NONAME
-	pj_lock_release                          @ 142 NONAME
-	pj_lock_tryacquire                       @ 143 NONAME
-	pj_log                                   @ 144 NONAME
-	pj_log_1                                 @ 145 NONAME
-	pj_log_2                                 @ 146 NONAME
-	pj_log_3                                 @ 147 NONAME
-	pj_log_4                                 @ 148 NONAME
-	pj_log_5                                 @ 149 NONAME
-	pj_log_get_decor                         @ 150 NONAME
-	pj_log_get_level                         @ 151 NONAME
-	pj_log_get_log_func                      @ 152 NONAME
-	pj_log_set_decor                         @ 153 NONAME
-	pj_log_set_level                         @ 154 NONAME
-	pj_log_set_log_func                      @ 155 NONAME
-	pj_log_write                             @ 156 NONAME
-	pj_mutex_create                          @ 157 NONAME
-	pj_mutex_create_recursive                @ 158 NONAME
-	pj_mutex_create_simple                   @ 159 NONAME
-	pj_mutex_destroy                         @ 160 NONAME
-	pj_mutex_lock                            @ 161 NONAME
-	pj_mutex_trylock                         @ 162 NONAME
-	pj_mutex_unlock                          @ 163 NONAME
-	pj_ntohl                                 @ 164 NONAME
-	pj_ntohs                                 @ 165 NONAME
-	pj_pool_alloc                            @ 166 NONAME
-	pj_pool_alloc_from_block                 @ 167 NONAME
-	pj_pool_allocate_find                    @ 168 NONAME
-	pj_pool_calloc                           @ 169 NONAME
-	pj_pool_create                           @ 170 NONAME
-	pj_pool_create_int                       @ 171 NONAME
-	pj_pool_create_on_buf                    @ 172 NONAME
-	pj_pool_destroy_int                      @ 173 NONAME
-	pj_pool_factory_default_policy           @ 174 NONAME
-	pj_pool_factory_get_default_policy       @ 175 NONAME
-	pj_pool_get_capacity                     @ 176 NONAME
-	pj_pool_get_used_size                    @ 177 NONAME
-	pj_pool_getobjname                       @ 178 NONAME
-	pj_pool_init_int                         @ 179 NONAME
-	pj_pool_release                          @ 180 NONAME
-	pj_pool_reset                            @ 181 NONAME
-	pj_rand                                  @ 182 NONAME
-	pj_rbtree_erase                          @ 183 NONAME
-	pj_rbtree_find                           @ 184 NONAME
-	pj_rbtree_first                          @ 185 NONAME
-	pj_rbtree_init                           @ 186 NONAME
-	pj_rbtree_insert                         @ 187 NONAME
-	pj_rbtree_last                           @ 188 NONAME
-	pj_rbtree_max_height                     @ 189 NONAME
-	pj_rbtree_min_height                     @ 190 NONAME
-	pj_rbtree_next                           @ 191 NONAME
-	pj_rbtree_prev                           @ 192 NONAME
-	pj_register_strerror                     @ 193 NONAME
-	pj_rwmutex_create                        @ 194 NONAME
-	pj_rwmutex_destroy                       @ 195 NONAME
-	pj_rwmutex_lock_read                     @ 196 NONAME
-	pj_rwmutex_lock_write                    @ 197 NONAME
-	pj_rwmutex_unlock_read                   @ 198 NONAME
-	pj_rwmutex_unlock_write                  @ 199 NONAME
-	pj_sem_create                            @ 200 NONAME
-	pj_sem_destroy                           @ 201 NONAME
-	pj_sem_post                              @ 202 NONAME
-	pj_sem_trywait                           @ 203 NONAME
-	pj_sem_wait                              @ 204 NONAME
-	pj_set_netos_error                       @ 205 NONAME
-	pj_set_os_error                          @ 206 NONAME
-	pj_shutdown                              @ 207 NONAME
-	pj_sock_accept                           @ 208 NONAME
-	pj_sock_bind                             @ 209 NONAME
-	pj_sock_bind_in                          @ 210 NONAME
-	pj_sock_close                            @ 211 NONAME
-	pj_sock_connect                          @ 212 NONAME
-	pj_sock_getpeername                      @ 213 NONAME
-	pj_sock_getsockname                      @ 214 NONAME
-	pj_sock_getsockopt                       @ 215 NONAME
-	pj_sock_listen                           @ 216 NONAME
-	pj_sock_recv                             @ 217 NONAME
-	pj_sock_recvfrom                         @ 218 NONAME
-	pj_sock_select                           @ 219 NONAME
-	pj_sock_send                             @ 220 NONAME
-	pj_sock_sendto                           @ 221 NONAME
-	pj_sock_setsockopt                       @ 222 NONAME
-	pj_sock_shutdown                         @ 223 NONAME
-	pj_sock_socket                           @ 224 NONAME
-	pj_sockaddr_in_init                      @ 225 NONAME
-	pj_sockaddr_in_set_str_addr              @ 226 NONAME
-	pj_srand                                 @ 227 NONAME
-	pj_str                                   @ 228 NONAME
-	pj_strassign                             @ 229 NONAME
-	pj_strcat                                @ 230 NONAME
-	pj_strcat2                               @ 231 NONAME
-	pj_strcmp                                @ 232 NONAME
-	pj_strcmp2                               @ 233 NONAME
-	pj_strcpy                                @ 234 NONAME
-	pj_strcpy2                               @ 235 NONAME
-	pj_strdup                                @ 236 NONAME
-	pj_strdup2                               @ 237 NONAME
-	pj_strdup2_with_null                     @ 238 NONAME
-	pj_strdup3                               @ 239 NONAME
-	pj_strdup_with_null                      @ 240 NONAME
-	pj_strerror                              @ 241 NONAME
-	pj_stricmp                               @ 242 NONAME
-	pj_stricmp2                              @ 243 NONAME
-	pj_strltrim                              @ 244 NONAME
-	pj_strncmp                               @ 245 NONAME
-	pj_strncmp2                              @ 246 NONAME
-	pj_strncpy                               @ 247 NONAME
-	pj_strncpy_with_null                     @ 248 NONAME
-	pj_strnicmp                              @ 249 NONAME
-	pj_strnicmp2                             @ 250 NONAME
-	pj_strrtrim                              @ 251 NONAME
-	pj_strtoul                               @ 252 NONAME
-	pj_strtoul2                              @ 253 NONAME
-	pj_strtrim                               @ 254 NONAME
-	pj_symbianos_poll                        @ 255 NONAME
-	pj_thread_create                         @ 256 NONAME
-	pj_thread_destroy                        @ 257 NONAME
-	pj_thread_get_name                       @ 258 NONAME
-	pj_thread_join                           @ 259 NONAME
-	pj_thread_local_alloc                    @ 260 NONAME
-	pj_thread_local_free                     @ 261 NONAME
-	pj_thread_local_get                      @ 262 NONAME
-	pj_thread_local_set                      @ 263 NONAME
-	pj_thread_register                       @ 264 NONAME
-	pj_thread_resume                         @ 265 NONAME
-	pj_thread_sleep                          @ 266 NONAME
-	pj_thread_this                           @ 267 NONAME
-	pj_time_decode                           @ 268 NONAME
-	pj_time_encode                           @ 269 NONAME
-	pj_time_gmt_to_local                     @ 270 NONAME
-	pj_time_local_to_gmt                     @ 271 NONAME
-	pj_time_val_normalize                    @ 272 NONAME
-	pj_timer_entry_init                      @ 273 NONAME
-	pj_timer_heap_cancel                     @ 274 NONAME
-	pj_timer_heap_count                      @ 275 NONAME
-	pj_timer_heap_create                     @ 276 NONAME
-	pj_timer_heap_destroy                    @ 277 NONAME
-	pj_timer_heap_earliest_time              @ 278 NONAME
-	pj_timer_heap_mem_size                   @ 279 NONAME
-	pj_timer_heap_poll                       @ 280 NONAME
-	pj_timer_heap_schedule                   @ 281 NONAME
-	pj_timer_heap_set_lock                   @ 282 NONAME
-	pj_timer_heap_set_max_timed_out_per_poll @ 283 NONAME
-	pj_unicode_to_ansi                       @ 284 NONAME
-	pj_utoa                                  @ 285 NONAME
-	pj_utoa_pad                              @ 286 NONAME
-	platform_strerror                        @ 287 NONAME
-	snprintf                                 @ 288 NONAME
-	vsnprintf                                @ 289 NONAME
+	PJ_VERSION                               @ 6 NONAME
+	pj_AF_INET                               @ 7 NONAME
+	pj_AF_INET6                              @ 8 NONAME
+	pj_AF_IRDA                               @ 9 NONAME
+	pj_AF_PACKET                             @ 10 NONAME
+	pj_AF_UNIX                               @ 11 NONAME
+	pj_IPTOS_LOWDELAY                        @ 12 NONAME
+	pj_IPTOS_MINCOST                         @ 13 NONAME
+	pj_IPTOS_RELIABILITY                     @ 14 NONAME
+	pj_IPTOS_THROUGHPUT                      @ 15 NONAME
+	pj_IP_TOS                                @ 16 NONAME
+	pj_MSG_DONTROUTE                         @ 17 NONAME
+	pj_MSG_OOB                               @ 18 NONAME
+	pj_MSG_PEEK                              @ 19 NONAME
+	pj_SOCK_DGRAM                            @ 20 NONAME
+	pj_SOCK_RAW                              @ 21 NONAME
+	pj_SOCK_RDM                              @ 22 NONAME
+	pj_SOCK_STREAM                           @ 23 NONAME
+	pj_SOL_IP                                @ 24 NONAME
+	pj_SOL_IPV6                              @ 25 NONAME
+	pj_SOL_SOCKET                            @ 26 NONAME
+	pj_SOL_TCP                               @ 27 NONAME
+	pj_SOL_UDP                               @ 28 NONAME
+	pj_SO_RCVBUF                             @ 29 NONAME
+	pj_SO_SNDBUF                             @ 30 NONAME
+	pj_SO_TYPE                               @ 31 NONAME
+	pj_ansi_to_unicode                       @ 32 NONAME
+	pj_array_erase                           @ 33 NONAME
+	pj_array_find                            @ 34 NONAME
+	pj_array_insert                          @ 35 NONAME
+	pj_atexit                                @ 36 NONAME
+	pj_atomic_add                            @ 37 NONAME
+	pj_atomic_add_and_get                    @ 38 NONAME
+	pj_atomic_create                         @ 39 NONAME
+	pj_atomic_dec                            @ 40 NONAME
+	pj_atomic_dec_and_get                    @ 41 NONAME
+	pj_atomic_destroy                        @ 42 NONAME
+	pj_atomic_get                            @ 43 NONAME
+	pj_atomic_inc                            @ 44 NONAME
+	pj_atomic_inc_and_get                    @ 45 NONAME
+	pj_atomic_set                            @ 46 NONAME
+	pj_caching_pool_destroy                  @ 47 NONAME
+	pj_caching_pool_init                     @ 48 NONAME
+	pj_create_random_string                  @ 49 NONAME
+	pj_create_unique_string                  @ 50 NONAME
+	pj_dump_config                           @ 51 NONAME
+	pj_elapsed_cycle                         @ 52 NONAME
+	pj_elapsed_msec                          @ 53 NONAME
+	pj_elapsed_nanosec                       @ 54 NONAME
+	pj_elapsed_time                          @ 55 NONAME
+	pj_elapsed_usec                          @ 56 NONAME
+	pj_enter_critical_section                @ 57 NONAME
+	pj_enum_ip_interface                     @ 58 NONAME
+	pj_enum_ip_route                         @ 59 NONAME
+	pj_exception_id_alloc                    @ 60 NONAME
+	pj_exception_id_free                     @ 61 NONAME
+	pj_exception_id_name                     @ 62 NONAME
+	pj_fifobuf_alloc                         @ 63 NONAME
+	pj_fifobuf_free                          @ 64 NONAME
+	pj_fifobuf_init                          @ 65 NONAME
+	pj_fifobuf_max_size                      @ 66 NONAME
+	pj_fifobuf_unalloc                       @ 67 NONAME
+	pj_file_close                            @ 68 NONAME
+	pj_file_delete                           @ 69 NONAME
+	pj_file_exists                           @ 70 NONAME
+	pj_file_flush                            @ 71 NONAME
+	pj_file_getpos                           @ 72 NONAME
+	pj_file_getstat                          @ 73 NONAME
+	pj_file_move                             @ 74 NONAME
+	pj_file_open                             @ 75 NONAME
+	pj_file_read                             @ 76 NONAME
+	pj_file_setpos                           @ 77 NONAME
+	pj_file_size                             @ 78 NONAME
+	pj_file_write                            @ 79 NONAME
+	pj_generate_unique_string                @ 80 NONAME
+	pj_get_netos_error                       @ 81 NONAME
+	pj_get_os_error                          @ 82 NONAME
+	pj_get_timestamp                         @ 83 NONAME
+	pj_get_timestamp_freq                    @ 84 NONAME
+	pj_get_version                           @ 85 NONAME
+	pj_gethostaddr                           @ 86 NONAME
+	pj_gethostbyname                         @ 87 NONAME
+	pj_gethostip                             @ 88 NONAME
+	pj_gethostname                           @ 89 NONAME
+	pj_getpid                                @ 90 NONAME
+	pj_gettimeofday                          @ 91 NONAME
+	pj_hash_calc                             @ 92 NONAME
+	pj_hash_calc_tolower                     @ 93 NONAME
+	pj_hash_count                            @ 94 NONAME
+	pj_hash_create                           @ 95 NONAME
+	pj_hash_first                            @ 96 NONAME
+	pj_hash_get                              @ 97 NONAME
+	pj_hash_next                             @ 98 NONAME
+	pj_hash_set                              @ 99 NONAME
+	pj_hash_set_np                           @ 100 NONAME
+	pj_hash_this                             @ 101 NONAME
+	pj_htonl                                 @ 102 NONAME
+	pj_htons                                 @ 103 NONAME
+	pj_inet_addr                             @ 104 NONAME
+	pj_inet_addr2                            @ 105 NONAME
+	pj_inet_aton                             @ 106 NONAME
+	pj_inet_ntoa                             @ 107 NONAME
+	pj_init                                  @ 108 NONAME
+	pj_ioqueue_accept                        @ 109 NONAME
+	pj_ioqueue_connect                       @ 110 NONAME
+	pj_ioqueue_create                        @ 111 NONAME
+	pj_ioqueue_destroy                       @ 112 NONAME
+	pj_ioqueue_get_user_data                 @ 113 NONAME
+	pj_ioqueue_is_pending                    @ 114 NONAME
+	pj_ioqueue_name                          @ 115 NONAME
+	pj_ioqueue_op_key_init                   @ 116 NONAME
+	pj_ioqueue_poll                          @ 117 NONAME
+	pj_ioqueue_post_completion               @ 118 NONAME
+	pj_ioqueue_recv                          @ 119 NONAME
+	pj_ioqueue_recvfrom                      @ 120 NONAME
+	pj_ioqueue_register_sock                 @ 121 NONAME
+	pj_ioqueue_send                          @ 122 NONAME
+	pj_ioqueue_sendto                        @ 123 NONAME
+	pj_ioqueue_set_lock                      @ 124 NONAME
+	pj_ioqueue_set_user_data                 @ 125 NONAME
+	pj_ioqueue_unregister                    @ 126 NONAME
+	pj_leave_critical_section                @ 127 NONAME
+	pj_list_erase                            @ 128 NONAME
+	pj_list_find_node                        @ 129 NONAME
+	pj_list_insert_after                     @ 130 NONAME
+	pj_list_insert_before                    @ 131 NONAME
+	pj_list_insert_nodes_after               @ 132 NONAME
+	pj_list_insert_nodes_before              @ 133 NONAME
+	pj_list_merge_first                      @ 134 NONAME
+	pj_list_merge_last                       @ 135 NONAME
+	pj_list_search                           @ 136 NONAME
+	pj_list_size                             @ 137 NONAME
+	pj_lock_acquire                          @ 138 NONAME
+	pj_lock_create_null_mutex                @ 139 NONAME
+	pj_lock_create_recursive_mutex           @ 140 NONAME
+	pj_lock_create_semaphore                 @ 141 NONAME
+	pj_lock_create_simple_mutex              @ 142 NONAME
+	pj_lock_destroy                          @ 143 NONAME
+	pj_lock_release                          @ 144 NONAME
+	pj_lock_tryacquire                       @ 145 NONAME
+	pj_log                                   @ 146 NONAME
+	pj_log_1                                 @ 147 NONAME
+	pj_log_2                                 @ 148 NONAME
+	pj_log_3                                 @ 149 NONAME
+	pj_log_4                                 @ 150 NONAME
+	pj_log_5                                 @ 151 NONAME
+	pj_log_get_decor                         @ 152 NONAME
+	pj_log_get_level                         @ 153 NONAME
+	pj_log_get_log_func                      @ 154 NONAME
+	pj_log_set_decor                         @ 155 NONAME
+	pj_log_set_level                         @ 156 NONAME
+	pj_log_set_log_func                      @ 157 NONAME
+	pj_log_write                             @ 158 NONAME
+	pj_mutex_create                          @ 159 NONAME
+	pj_mutex_create_recursive                @ 160 NONAME
+	pj_mutex_create_simple                   @ 161 NONAME
+	pj_mutex_destroy                         @ 162 NONAME
+	pj_mutex_lock                            @ 163 NONAME
+	pj_mutex_trylock                         @ 164 NONAME
+	pj_mutex_unlock                          @ 165 NONAME
+	pj_ntohl                                 @ 166 NONAME
+	pj_ntohs                                 @ 167 NONAME
+	pj_pool_alloc                            @ 168 NONAME
+	pj_pool_alloc_from_block                 @ 169 NONAME
+	pj_pool_allocate_find                    @ 170 NONAME
+	pj_pool_calloc                           @ 171 NONAME
+	pj_pool_create                           @ 172 NONAME
+	pj_pool_create_int                       @ 173 NONAME
+	pj_pool_create_on_buf                    @ 174 NONAME
+	pj_pool_destroy_int                      @ 175 NONAME
+	pj_pool_factory_default_policy           @ 176 NONAME
+	pj_pool_factory_get_default_policy       @ 177 NONAME
+	pj_pool_get_capacity                     @ 178 NONAME
+	pj_pool_get_used_size                    @ 179 NONAME
+	pj_pool_getobjname                       @ 180 NONAME
+	pj_pool_init_int                         @ 181 NONAME
+	pj_pool_release                          @ 182 NONAME
+	pj_pool_reset                            @ 183 NONAME
+	pj_rand                                  @ 184 NONAME
+	pj_rbtree_erase                          @ 185 NONAME
+	pj_rbtree_find                           @ 186 NONAME
+	pj_rbtree_first                          @ 187 NONAME
+	pj_rbtree_init                           @ 188 NONAME
+	pj_rbtree_insert                         @ 189 NONAME
+	pj_rbtree_last                           @ 190 NONAME
+	pj_rbtree_max_height                     @ 191 NONAME
+	pj_rbtree_min_height                     @ 192 NONAME
+	pj_rbtree_next                           @ 193 NONAME
+	pj_rbtree_prev                           @ 194 NONAME
+	pj_register_strerror                     @ 195 NONAME
+	pj_rwmutex_create                        @ 196 NONAME
+	pj_rwmutex_destroy                       @ 197 NONAME
+	pj_rwmutex_lock_read                     @ 198 NONAME
+	pj_rwmutex_lock_write                    @ 199 NONAME
+	pj_rwmutex_unlock_read                   @ 200 NONAME
+	pj_rwmutex_unlock_write                  @ 201 NONAME
+	pj_sem_create                            @ 202 NONAME
+	pj_sem_destroy                           @ 203 NONAME
+	pj_sem_post                              @ 204 NONAME
+	pj_sem_trywait                           @ 205 NONAME
+	pj_sem_wait                              @ 206 NONAME
+	pj_set_netos_error                       @ 207 NONAME
+	pj_set_os_error                          @ 208 NONAME
+	pj_shutdown                              @ 209 NONAME
+	pj_sock_accept                           @ 210 NONAME
+	pj_sock_bind                             @ 211 NONAME
+	pj_sock_bind_in                          @ 212 NONAME
+	pj_sock_close                            @ 213 NONAME
+	pj_sock_connect                          @ 214 NONAME
+	pj_sock_getpeername                      @ 215 NONAME
+	pj_sock_getsockname                      @ 216 NONAME
+	pj_sock_getsockopt                       @ 217 NONAME
+	pj_sock_listen                           @ 218 NONAME
+	pj_sock_recv                             @ 219 NONAME
+	pj_sock_recvfrom                         @ 220 NONAME
+	pj_sock_select                           @ 221 NONAME
+	pj_sock_send                             @ 222 NONAME
+	pj_sock_sendto                           @ 223 NONAME
+	pj_sock_setsockopt                       @ 224 NONAME
+	pj_sock_shutdown                         @ 225 NONAME
+	pj_sock_socket                           @ 226 NONAME
+	pj_sockaddr_in_init                      @ 227 NONAME
+	pj_sockaddr_in_set_str_addr              @ 228 NONAME
+	pj_srand                                 @ 229 NONAME
+	pj_str                                   @ 230 NONAME
+	pj_strassign                             @ 231 NONAME
+	pj_strcat                                @ 232 NONAME
+	pj_strcat2                               @ 233 NONAME
+	pj_strcmp                                @ 234 NONAME
+	pj_strcmp2                               @ 235 NONAME
+	pj_strcpy                                @ 236 NONAME
+	pj_strcpy2                               @ 237 NONAME
+	pj_strdup                                @ 238 NONAME
+	pj_strdup2                               @ 239 NONAME
+	pj_strdup2_with_null                     @ 240 NONAME
+	pj_strdup3                               @ 241 NONAME
+	pj_strdup_with_null                      @ 242 NONAME
+	pj_strerror                              @ 243 NONAME
+	pj_stricmp                               @ 244 NONAME
+	pj_stricmp2                              @ 245 NONAME
+	pj_strltrim                              @ 246 NONAME
+	pj_strncmp                               @ 247 NONAME
+	pj_strncmp2                              @ 248 NONAME
+	pj_strncpy                               @ 249 NONAME
+	pj_strncpy_with_null                     @ 250 NONAME
+	pj_strnicmp                              @ 251 NONAME
+	pj_strnicmp2                             @ 252 NONAME
+	pj_strrtrim                              @ 253 NONAME
+	pj_strtoul                               @ 254 NONAME
+	pj_strtoul2                              @ 255 NONAME
+	pj_strtrim                               @ 256 NONAME
+	pj_symbianos_poll                        @ 257 NONAME
+	pj_thread_create                         @ 258 NONAME
+	pj_thread_destroy                        @ 259 NONAME
+	pj_thread_get_name                       @ 260 NONAME
+	pj_thread_join                           @ 261 NONAME
+	pj_thread_local_alloc                    @ 262 NONAME
+	pj_thread_local_free                     @ 263 NONAME
+	pj_thread_local_get                      @ 264 NONAME
+	pj_thread_local_set                      @ 265 NONAME
+	pj_thread_register                       @ 266 NONAME
+	pj_thread_resume                         @ 267 NONAME
+	pj_thread_sleep                          @ 268 NONAME
+	pj_thread_this                           @ 269 NONAME
+	pj_time_decode                           @ 270 NONAME
+	pj_time_encode                           @ 271 NONAME
+	pj_time_gmt_to_local                     @ 272 NONAME
+	pj_time_local_to_gmt                     @ 273 NONAME
+	pj_time_val_normalize                    @ 274 NONAME
+	pj_timer_entry_init                      @ 275 NONAME
+	pj_timer_heap_cancel                     @ 276 NONAME
+	pj_timer_heap_count                      @ 277 NONAME
+	pj_timer_heap_create                     @ 278 NONAME
+	pj_timer_heap_destroy                    @ 279 NONAME
+	pj_timer_heap_earliest_time              @ 280 NONAME
+	pj_timer_heap_mem_size                   @ 281 NONAME
+	pj_timer_heap_poll                       @ 282 NONAME
+	pj_timer_heap_schedule                   @ 283 NONAME
+	pj_timer_heap_set_lock                   @ 284 NONAME
+	pj_timer_heap_set_max_timed_out_per_poll @ 285 NONAME
+	pj_unicode_to_ansi                       @ 286 NONAME
+	pj_utoa                                  @ 287 NONAME
+	pj_utoa_pad                              @ 288 NONAME
+	platform_strerror                        @ 289 NONAME
+	snprintf                                 @ 290 NONAME
+	vsnprintf                                @ 291 NONAME