Index: pjproject/trunk/build.symbian/pjsua_libU.def
===================================================================
--- pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1417)
+++ pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1424)
@@ -18,97 +18,98 @@
 	pjsua_acc_set_default                    @ 17 NONAME
 	pjsua_acc_set_online_status              @ 18 NONAME
-	pjsua_acc_set_registration               @ 19 NONAME
-	pjsua_acc_set_transport                  @ 20 NONAME
-	pjsua_buddy_add                          @ 21 NONAME
-	pjsua_buddy_config_default               @ 22 NONAME
-	pjsua_buddy_del                          @ 23 NONAME
-	pjsua_buddy_get_info                     @ 24 NONAME
-	pjsua_buddy_is_valid                     @ 25 NONAME
-	pjsua_buddy_subscribe_pres               @ 26 NONAME
-	pjsua_call_answer                        @ 27 NONAME
-	pjsua_call_dial_dtmf                     @ 28 NONAME
-	pjsua_call_dump                          @ 29 NONAME
-	pjsua_call_get_conf_port                 @ 30 NONAME
-	pjsua_call_get_count                     @ 31 NONAME
-	pjsua_call_get_info                      @ 32 NONAME
-	pjsua_call_get_max_count                 @ 33 NONAME
-	pjsua_call_get_user_data                 @ 34 NONAME
-	pjsua_call_hangup                        @ 35 NONAME
-	pjsua_call_hangup_all                    @ 36 NONAME
-	pjsua_call_has_media                     @ 37 NONAME
-	pjsua_call_is_active                     @ 38 NONAME
-	pjsua_call_make_call                     @ 39 NONAME
-	pjsua_call_reinvite                      @ 40 NONAME
-	pjsua_call_send_im                       @ 41 NONAME
-	pjsua_call_send_typing_ind               @ 42 NONAME
-	pjsua_call_set_hold                      @ 43 NONAME
-	pjsua_call_set_user_data                 @ 44 NONAME
-	pjsua_call_xfer                          @ 45 NONAME
-	pjsua_call_xfer_replaces                 @ 46 NONAME
-	pjsua_codec_get_param                    @ 47 NONAME
-	pjsua_codec_set_param                    @ 48 NONAME
-	pjsua_codec_set_priority                 @ 49 NONAME
-	pjsua_conf_add_port                      @ 50 NONAME
-	pjsua_conf_adjust_rx_level               @ 51 NONAME
-	pjsua_conf_adjust_tx_level               @ 52 NONAME
-	pjsua_conf_connect                       @ 53 NONAME
-	pjsua_conf_disconnect                    @ 54 NONAME
-	pjsua_conf_get_active_ports              @ 55 NONAME
-	pjsua_conf_get_max_ports                 @ 56 NONAME
-	pjsua_conf_get_port_info                 @ 57 NONAME
-	pjsua_conf_get_signal_level              @ 58 NONAME
-	pjsua_conf_remove_port                   @ 59 NONAME
-	pjsua_config_default                     @ 60 NONAME
-	pjsua_config_dup                         @ 61 NONAME
-	pjsua_create                             @ 62 NONAME
-	pjsua_destroy                            @ 63 NONAME
-	pjsua_dump                               @ 64 NONAME
-	pjsua_enum_accs                          @ 65 NONAME
-	pjsua_enum_buddies                       @ 66 NONAME
-	pjsua_enum_calls                         @ 67 NONAME
-	pjsua_enum_codecs                        @ 68 NONAME
-	pjsua_enum_conf_ports                    @ 69 NONAME
-	pjsua_enum_snd_devs                      @ 70 NONAME
-	pjsua_enum_transports                    @ 71 NONAME
-	pjsua_get_buddy_count                    @ 72 NONAME
-	pjsua_get_ec_tail                        @ 73 NONAME
-	pjsua_get_pjmedia_endpt                  @ 74 NONAME
-	pjsua_get_pjsip_endpt                    @ 75 NONAME
-	pjsua_get_pool_factory                   @ 76 NONAME
-	pjsua_get_snd_dev                        @ 77 NONAME
-	pjsua_handle_events                      @ 78 NONAME
-	pjsua_im_send                            @ 79 NONAME
-	pjsua_im_typing                          @ 80 NONAME
-	pjsua_init                               @ 81 NONAME
-	pjsua_logging_config_default             @ 82 NONAME
-	pjsua_logging_config_dup                 @ 83 NONAME
-	pjsua_media_config_default               @ 84 NONAME
-	pjsua_media_transports_create            @ 85 NONAME
-	pjsua_msg_data_init                      @ 86 NONAME
-	pjsua_perror                             @ 87 NONAME
-	pjsua_player_create                      @ 88 NONAME
-	pjsua_player_destroy                     @ 89 NONAME
-	pjsua_player_get_conf_port               @ 90 NONAME
-	pjsua_player_get_port                    @ 91 NONAME
-	pjsua_player_set_pos                     @ 92 NONAME
-	pjsua_playlist_create                    @ 93 NONAME
-	pjsua_pool_create                        @ 94 NONAME
-	pjsua_pres_dump                          @ 95 NONAME
-	pjsua_reconfigure_logging                @ 96 NONAME
-	pjsua_recorder_create                    @ 97 NONAME
-	pjsua_recorder_destroy                   @ 98 NONAME
-	pjsua_recorder_get_conf_port             @ 99 NONAME
-	pjsua_recorder_get_port                  @ 100 NONAME
-	pjsua_set_ec                             @ 101 NONAME
-	pjsua_set_no_snd_dev                     @ 102 NONAME
-	pjsua_set_null_snd_dev                   @ 103 NONAME
-	pjsua_set_snd_dev                        @ 104 NONAME
-	pjsua_start                              @ 105 NONAME
-	pjsua_transport_close                    @ 106 NONAME
-	pjsua_transport_config_default           @ 107 NONAME
-	pjsua_transport_config_dup               @ 108 NONAME
-	pjsua_transport_create                   @ 109 NONAME
-	pjsua_transport_get_info                 @ 110 NONAME
-	pjsua_transport_register                 @ 111 NONAME
-	pjsua_transport_set_enable               @ 112 NONAME
-	pjsua_verify_sip_url                     @ 113 NONAME
+	pjsua_acc_set_online_status2             @ 19 NONAME
+	pjsua_acc_set_registration               @ 20 NONAME
+	pjsua_acc_set_transport                  @ 21 NONAME
+	pjsua_buddy_add                          @ 22 NONAME
+	pjsua_buddy_config_default               @ 23 NONAME
+	pjsua_buddy_del                          @ 24 NONAME
+	pjsua_buddy_get_info                     @ 25 NONAME
+	pjsua_buddy_is_valid                     @ 26 NONAME
+	pjsua_buddy_subscribe_pres               @ 27 NONAME
+	pjsua_call_answer                        @ 28 NONAME
+	pjsua_call_dial_dtmf                     @ 29 NONAME
+	pjsua_call_dump                          @ 30 NONAME
+	pjsua_call_get_conf_port                 @ 31 NONAME
+	pjsua_call_get_count                     @ 32 NONAME
+	pjsua_call_get_info                      @ 33 NONAME
+	pjsua_call_get_max_count                 @ 34 NONAME
+	pjsua_call_get_user_data                 @ 35 NONAME
+	pjsua_call_hangup                        @ 36 NONAME
+	pjsua_call_hangup_all                    @ 37 NONAME
+	pjsua_call_has_media                     @ 38 NONAME
+	pjsua_call_is_active                     @ 39 NONAME
+	pjsua_call_make_call                     @ 40 NONAME
+	pjsua_call_reinvite                      @ 41 NONAME
+	pjsua_call_send_im                       @ 42 NONAME
+	pjsua_call_send_typing_ind               @ 43 NONAME
+	pjsua_call_set_hold                      @ 44 NONAME
+	pjsua_call_set_user_data                 @ 45 NONAME
+	pjsua_call_xfer                          @ 46 NONAME
+	pjsua_call_xfer_replaces                 @ 47 NONAME
+	pjsua_codec_get_param                    @ 48 NONAME
+	pjsua_codec_set_param                    @ 49 NONAME
+	pjsua_codec_set_priority                 @ 50 NONAME
+	pjsua_conf_add_port                      @ 51 NONAME
+	pjsua_conf_adjust_rx_level               @ 52 NONAME
+	pjsua_conf_adjust_tx_level               @ 53 NONAME
+	pjsua_conf_connect                       @ 54 NONAME
+	pjsua_conf_disconnect                    @ 55 NONAME
+	pjsua_conf_get_active_ports              @ 56 NONAME
+	pjsua_conf_get_max_ports                 @ 57 NONAME
+	pjsua_conf_get_port_info                 @ 58 NONAME
+	pjsua_conf_get_signal_level              @ 59 NONAME
+	pjsua_conf_remove_port                   @ 60 NONAME
+	pjsua_config_default                     @ 61 NONAME
+	pjsua_config_dup                         @ 62 NONAME
+	pjsua_create                             @ 63 NONAME
+	pjsua_destroy                            @ 64 NONAME
+	pjsua_dump                               @ 65 NONAME
+	pjsua_enum_accs                          @ 66 NONAME
+	pjsua_enum_buddies                       @ 67 NONAME
+	pjsua_enum_calls                         @ 68 NONAME
+	pjsua_enum_codecs                        @ 69 NONAME
+	pjsua_enum_conf_ports                    @ 70 NONAME
+	pjsua_enum_snd_devs                      @ 71 NONAME
+	pjsua_enum_transports                    @ 72 NONAME
+	pjsua_get_buddy_count                    @ 73 NONAME
+	pjsua_get_ec_tail                        @ 74 NONAME
+	pjsua_get_pjmedia_endpt                  @ 75 NONAME
+	pjsua_get_pjsip_endpt                    @ 76 NONAME
+	pjsua_get_pool_factory                   @ 77 NONAME
+	pjsua_get_snd_dev                        @ 78 NONAME
+	pjsua_handle_events                      @ 79 NONAME
+	pjsua_im_send                            @ 80 NONAME
+	pjsua_im_typing                          @ 81 NONAME
+	pjsua_init                               @ 82 NONAME
+	pjsua_logging_config_default             @ 83 NONAME
+	pjsua_logging_config_dup                 @ 84 NONAME
+	pjsua_media_config_default               @ 85 NONAME
+	pjsua_media_transports_create            @ 86 NONAME
+	pjsua_msg_data_init                      @ 87 NONAME
+	pjsua_perror                             @ 88 NONAME
+	pjsua_player_create                      @ 89 NONAME
+	pjsua_player_destroy                     @ 90 NONAME
+	pjsua_player_get_conf_port               @ 91 NONAME
+	pjsua_player_get_port                    @ 92 NONAME
+	pjsua_player_set_pos                     @ 93 NONAME
+	pjsua_playlist_create                    @ 94 NONAME
+	pjsua_pool_create                        @ 95 NONAME
+	pjsua_pres_dump                          @ 96 NONAME
+	pjsua_reconfigure_logging                @ 97 NONAME
+	pjsua_recorder_create                    @ 98 NONAME
+	pjsua_recorder_destroy                   @ 99 NONAME
+	pjsua_recorder_get_conf_port             @ 100 NONAME
+	pjsua_recorder_get_port                  @ 101 NONAME
+	pjsua_set_ec                             @ 102 NONAME
+	pjsua_set_no_snd_dev                     @ 103 NONAME
+	pjsua_set_null_snd_dev                   @ 104 NONAME
+	pjsua_set_snd_dev                        @ 105 NONAME
+	pjsua_start                              @ 106 NONAME
+	pjsua_transport_close                    @ 107 NONAME
+	pjsua_transport_config_default           @ 108 NONAME
+	pjsua_transport_config_dup               @ 109 NONAME
+	pjsua_transport_create                   @ 110 NONAME
+	pjsua_transport_get_info                 @ 111 NONAME
+	pjsua_transport_register                 @ 112 NONAME
+	pjsua_transport_set_enable               @ 113 NONAME
+	pjsua_verify_sip_url                     @ 114 NONAME